---
title: TransformStream
slug: Web/API/TransformStream
tags:
  - Streams API
---
<p>{{APIRef("Streams")}}</p>

<p><span class="seoSummary">The <code>TransformStream</code> interface of the <a href="/en-US/docs/Web/API/Streams_API">Streams API</a> represents a set of transformable data.</span></p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("TransformStream.TransformStream", "TransformStream()")}}</dt>
 <dd>Creates and returns a transform stream object from the given handlers.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("TransformStream.readable")}} {{readonlyInline}}</dt>
 <dd>The <code>readable</code> end of a TransformStream.</dd>
 <dt>{{domxref("TransformStream.writable")}} {{readonlyInline}}</dt>
 <dd>The <code>writable</code> end of a TransformStream.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>None</p>

<h2 id="Examples">Examples</h2>

<h3 id="Anything-to-uint8array_stream">Anything-to-uint8array stream</h3>

<p>In the following example, a transform stream passes through all chunks it receives as {{domxref("Uint8Array")}} values.</p>

<pre class="brush: js notranslate">const transformContent = {
  start() {}, // required.
  async transform(chunk, controller) {
    chunk = await chunk
    switch (typeof chunk) {
      case 'object':
        // just say the stream is done I guess
        if (chunk === null) controller.terminate()
        else if (ArrayBuffer.isView(chunk))
          controller.enqueue(new Uint8Array(chunk.buffer, chunk.byteOffset, chunk.byteLength))
        else if (Array.isArray(chunk) &amp;&amp; chunk.every(value =&gt; typeof value === 'number'))
          controller.enqueue(new Uint8Array(chunk))
        else if ('function' === typeof chunk.valueOf &amp;&amp; chunk.valueOf() !== chunk)
          this.transform(chunk.valueOf(), controller) // hack
        else if ('toJSON' in chunk) this.transform(JSON.stringify(chunk), controller)
        break
      case 'symbol':
        controller.error("Cannot send a symbol as a chunk part")
        break
      case 'undefined':
        controller.error("Cannot send undefined as a chunk part")
        break
      default:
        controller.enqueue(this.textencoder.encode(String(chunk)))
        break
  },
  flush() { /* do any destructor work here */ }
}

class AnyToU8Stream extends TransformStream {
  constructor() {
    super({...transformContent, textencoder: new TextEncoder()})
  }
}
</pre>

<h3 id="Polyfilling_TextEncoderStream_and_TextDecoderStream">Polyfilling TextEncoderStream and TextDecoderStream</h3>

<p>Note that this is deprecated by the native constructors. This is intended as a polyfill for unsupported platforms.</p>

<pre class="brush: js notranslate">const tes = {
  start(){this.encoder = new TextEncoder()},
  transform(chunk, controller) {
    controller.enqueue(this.encoder.encode(chunk))
  }
}

let _jstes_wm = new WeakMap(); /* info holder */
class JSTextEncoderStream extends TransformStream {
  constructor() {
    let t = {...tes}

    super(t)
    _jstes_wm.set(this, t)
  }
  get encoding() {return _jstes_wm.get(this).encoder.encoding}
}
</pre>

<p>Similarly, <code>TextDecoderStream</code> can be written as such:</p>

<pre class="brush: js notranslate">const tds = {
  start(){
    this.decoder = new TextDecoder(this.encoding, this.options)
  },
  transform(chunk, controller) {
    controller.enqueue(this.decoder.decode(chunk, { stream: true }))
  }
}

let _jstds_wm = new WeakMap(); /* info holder */
class JSTextDecoderStream extends TransformStream {
  constructor(encoding = 'utf-8', {...options} = {}) {
    let t = {...tds, encoding, options}

    super(t)
    _jstds_wm.set(this, t)
  }
  get encoding() {return _jstds_wm.get(this).decoder.encoding}
  get fatal() {return _jstds_wm.get(this).decoder.fatal}
  get ignoreBOM() {return _jstds_wm.get(this).decoder.ignoreBOM}
}
</pre>

<h3 id="Chaining_multiple_ReadableStreams_together">Chaining multiple ReadableStreams together</h3>

<p>This is a useful one, where multiple streams can be conjoined. Examples include building a PWA with progressive loading and progressive streaming.</p>

<pre class="brush: js notranslate">let responses = [ /* conjoined response tree */ ]
let {readable, writable} = new TransformStream

responses.reduce(
  (a, res, i, arr) =&gt; a.then(() =&gt; res.pipeTo(writable, {preventClose: (i+1) !== arr.length})),
  Promise.resolve()
)
</pre>

<p>Note that this is not resilient to other influences.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Streams','#ts-class','TransformStream')}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.TransformStream")}}</p>
</div>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="https://whatwg-stream-visualizer.glitch.me/">WHATWG Stream Visualiser</a>, for a basic visualisation of readable, writable, and transform streams.</li>
</ul>
